//
// BotzProjectileStore
// Used to store all projectiles flying around for evasion purposes
//
// Have suggestions? Contact me.
// caco_fff@hotmail.com - Higor at UT99.org

class BotzProjectileStore expands InfoPoint;


var() Projectile ProjList[96]; //Para empezar, 96
var int HighestProj;	//Optimizacion

//New functionality: recently spawned projectile always to slot 0
function AddProj( projectile Other)
{
	local int i;

	For ( i=0 ; i<96 ; i++ )
		if ( ProjList[i] == none )
		{	ProjList[i] = ProjList[0];
			ProjList[0] = Other;
			i--;
			break;
		}

	if ( i >= 96 )
	 {
		i = Rand(96); //Discard a random projectile
		ProjList[i] = Other;
	}


	if ( i > HighestProj ) //This projectile is the highest index
		HighestProj = i;
	else if ( ProjList[HighestProj] == none )
		HighestProj--;
}

//Simple Accessor
function Projectile GetProj( int i)
{
	return ProjList[i];
}


function Projectile NextDangerProj( BotZ B, float Dist, out int OI)
{
	if ( HighestProj < 0 )
		return none;
	if ( OI == 9999 )
		OI = HighestProj;

	if ( false )
	{
		AGAIN:
		if (--OI < 0)
			return none;
	}

	if ( (ProjList[OI] == none) || ProjList[OI].bDeleteMe )
		Goto AGAIN;

	if ( (ProjList[OI].Instigator == B) || (VSize(ProjList[OI].Location - B.Location) - VSize(ProjList[OI].Velocity)*0.1) > Dist )
		Goto AGAIN;

	OI--;
	return ProjList[OI+1];
}

event Tick( float DeltaTime)
{
	local int i;

	While ( (HighestProj >= 0) && (ProjList[HighestProj] == none || ProjList[HighestProj].bDeleteMe) )
		ProjList[HighestProj--] = none;

	For ( i=HighestProj ; i>=0 ; i-- )
	{
		if ( (ProjList[i] != none) && ProjList[i].bDeleteMe )
			ProjList[i] = none; //Clear references
	}
}

defaultproperties
{
	HighestProj=-1
}